spec:
  inputs:
    stage:
      default: validate
---

checkov:
  stage: $[[ inputs.stage ]]
  needs: []
  image:
    name: ghcr.io/bridgecrewio/checkov:${GL_ASDF_CHECKOV_VERSION}
    entrypoint: [""]
  script:
    - |
      mkdir -p checkov-output
      (checkov --config-file .checkov.yaml -o cli -o junitxml --output-file-path checkov-output &> /dev/null) && {
        echo "--------------------------------------------------------"
        echo "Checkov passed:"
        echo "--------------------------------------------------------"
        grep -B 2 "Passed checks:" checkov-output/results_cli.txt
      } || {
        echo "--------------------------------------------------------"
        echo "Checkov failed:"
        echo "--------------------------------------------------------"
        cat checkov-output/results_cli.txt
        echo "--------------------------------------------------------"
        echo "checkov output is available via artifacts for this job"
        echo "--------------------------------------------------------"
        exit 1
      }
  after_script: |
    cat <<-EOD
    ----------------------------------------------------------
    Need help? Documentation on the checkov CI job can be found at:
    https://gitlab.com/gitlab-com/gl-infra/common-ci-tasks/-/blob/main/checkov.md
    EOD
  artifacts:
    when: always
    reports:
      junit: "checkov-output/results_junitxml.xml"
    paths:
      - "checkov-output/*"
  rules:
    - if: $CI_PIPELINE_SOURCE == "parent_pipeline"
      exists:
        - .checkov.yaml
    - if: $CI_PIPELINE_SOURCE == "merge_request_event" || ($CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $CI_PIPELINE_SOURCE != "schedule")
      exists:
        - .checkov.yaml
  # Automatically retry on any system blips
  retry:
    max: 2
    when:
      - runner_system_failure
